-- Copyright (c) 2012 DisplayLink (UK) Ltd.

on searchAndReplace(sourceText, findText, replaceText)
	set {atid, AppleScript's text item delimiters} to {AppleScript's text item delimiters, findText}
	set tempText to text items of sourceText
	set AppleScript's text item delimiters to replaceText
	set sourceText to tempText as string
	set AppleScript's text item delimiters to atid
	return sourceText
end searchAndReplace

on run argv
  set logNodeFound to false
	set dlXmlFile to "/Library/Application Support/DisplayLink/.dl.xml"
	-- parsing XML
	tell application "System Events"
		tell XML element 1 of contents of XML file dlXmlFile
			repeat with anElement from 1 to (count of XML elements)
				set elementAttribute to (value of XML attribute of XML element anElement) as string
				if elementAttribute = "HKEY_LOCAL_MACHINE" then
					repeat with nodeIndex from 1 to (count of XML elements of XML element 1 of XML element 1 of XML element anElement)
						set nodeElem to (value of XML attribute of XML element nodeIndex of XML element 1 of XML element 1 of XML element anElement) as string
						if nodeElem = "Logger" then
							set logNodeFound to true
							set logVerbosity to (value of XML element 1 of XML element nodeIndex of XML element 1 of XML element 1 of XML element anElement) as string
							log logVerbosity
						end if
					end repeat
				end if
			end repeat
		end tell
	end tell
	-- saving modified configuration file 
	set XMLfilename to POSIX file dlXmlFile as text
	set thexml to (read file XMLfilename) as text
  if logNodeFound then
    set modifiedXml to searchAndReplace(thexml, logVerbosity, item 1 of argv)
  else
    set modifiedXml to searchAndReplace(thexml, "<node name=\"DisplayLink\">","<node name=\"DisplayLink\">\n<node name=\"Logger\">\n<value name=\"verbosity\">" & item 1 of argv & "</value>\n</node>")
  end if
	try
		set newDlXmlFile to XMLfilename as alias
		
		open for access newDlXmlFile with write permission
		write modifiedXml to newDlXmlFile
		close access newDlXmlFile
		return true
    on error
		try
			close access file newDlXmlFile
		end try
		return false
	end try
  -- killing DLM & DLUA
  do shell script ("killall -9 DisplayLinkManager")
  do shell script ("killall -9 DisplayLinkUserAgent")
  
end run
